//+------------------------------------------------------------------+
//|                                                         iVAR.mq4 |
//|                                        (C)opyright  2008, Ilnur |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
/*      , 
 *      2^n.  
 * ,        
 *  ,      .
 *
 * ..   . -    
 *     .
 */
//----  
#property copyright "(C)opyright  2008, Ilnur"
//----    
#property link      "http://www.metaquotes.net"
//----   
#property version   "1.01"
#property description " "
//----     
#property indicator_separate_window
//----    1
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1 DRAW_LINE
//----       
#property indicator_color1 clrRed
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----    
#property indicator_label1  "iVAR"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 0.5
#property indicator_levelcolor clrBlue
#property indicator_levelstyle STYLE_DASHDOTDOT
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int N=5; //    
//+----------------------------------------------+
//----   ,    
//----      
double ExtLineBuffer[];
//----      
int Num;
//----      
double MathLogX2;
//----      
int StartBars;
//+------------------------------------------------------------------+
//| Searching index of the highest bar                               |
//+------------------------------------------------------------------+
int iHighest(const double &array[],//      
             int count,            //    (        ),      
             int startPos)         //  (   )  ,      
  {
//----
   int index=startPos;
//----     
   if(startPos<0)
     {
      Print("    iHighest, startPos = ",startPos);
      return(0);
     }
//----   startPos  
   if(count<0) count=startPos;
//----
   double max=array[startPos];
//----  
   for(int i=startPos; i<startPos+count; i++)
     {
      if(array[i]>max)
        {
         index=i;
         max=array[i];
        }
     }
//----    
   return(index);
  }
//+------------------------------------------------------------------+
//| Searching index of the lowest bar                                |
//+------------------------------------------------------------------+
int iLowest(const double &array[],//      
            int count,            //    (        ),      
            int startPos)         //  (   )  ,      
  {
//----
   int index=startPos;
//----     
   if(startPos<0)
     {
      Print("    iLowest, startPos = ",startPos);
      return(0);
     }
//----   startPos  
   if(count<0) count=startPos;
//----
   double min=array[startPos];
//----  
   for(int i=startPos; i<startPos+count; i++)
     {
      if(array[i]<min)
        {
         index=i;
         min=array[i];
        }
     }
//----    
   return(index);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   StartBars=int(MathPow(2,N));
//----   
   Num=N;
   MathLogX2=MathLog(2.0);
//----    ExtLineBuffer   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//----      
   string shortname;
   StringConcatenate(shortname,"iVAR(",N,")");
//----       
   PlotIndexSetString(0,PLOT_LABEL,shortname);
//----      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(ExtLineBuffer,true);
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<StartBars) return(0);
//----    
   int limit,ihigh,ilow,nInterval;
   double Delta,Xc,Yc,Sx,Sy,Sxx,Sxy;
//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      limit=rates_total-StartBars-1; //      
   else limit=rates_total-prev_calculated; //      
//----         
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
//----    
   for(int bar=limit; bar>=0; bar--)
     {
      Sx = 0;
      Sy = 0;
      Sxx = 0;
      Sxy = 0;
      //----
      for(int iii=0; iii<=N; iii++)
        {
         Delta=0;
         nInterval=int(MathPow(2,N-iii));
         //----        
         for(int kkk=0; kkk<MathPow(2,iii); kkk++)
           {
            ihigh = iHighest(high,nInterval,bar+nInterval*kkk);
            ilow  = iLowest (low, nInterval,bar+nInterval*kkk);
            Delta+= high[ihigh]-low[ilow];
           }
         //----       
         Xc = (N-iii)*MathLogX2;
         Yc = MathLog(Delta);
         //----          
         Sx += Xc;
         Sy += Yc;
         Sxx += Xc*Xc;
         Sxy += Xc*Yc;
        }
      //----    (   )
      ExtLineBuffer[bar]=-(Sx*Sy-Num*Sxy)/(Sx*Sx-Num*Sxx);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
